def assignCameraParameters(root, camera, camIdx):
   camera.SetPosition(   float(root[camIdx-1][1][0][0][0][0].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][0][1].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][0][2].attrib['value']) )
   camera.SetFocalPoint( float(root[camIdx-1][1][0][0][1][0].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][1][1].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][1][2].attrib['value']) )
   camera.SetViewUp(     float(root[camIdx-1][1][0][0][2][0].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][2][1].attrib['value']) ,
                         float(root[camIdx-1][1][0][0][2][2].attrib['value']) )
   camera.SetParallelScale(float(root[camIdx-1][1][0][0][6][0].attrib['value']))
def loadCamera(cameraFile):
    import xml.etree.ElementTree as ET
    tree = ET.parse(cameraFile)
    camera = GetActiveCamera()
    assignCameraParameters(tree.getroot(), camera, 1)

def yawClip(inClip, yawdeg):

    theta=yawdeg*np.pi/180.0

    Rx = np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0, np.sin(theta), np.cos(theta)]])
    Ry = np.array([[np.cos(theta),0,np.sin(theta)],[0,1,0],[-np.sin(theta), 0, np.cos(theta)]])
    Rz = np.array([[np.cos(theta), -np.sin(theta),0],[np.sin(theta), np.cos(theta),0],[0,0,1]])
    ## doing y rotation here
    R=Ry

    inClip.ClipType.Rotation = [0.0, yawdeg, 0.0]

    ## want this rotated about 2.35 0.15 0
    x0 = np.array(inClip.ClipType.Position)
    dx = np.array(inClip.ClipType.Length)

    # no reflection, so double width and shift
    x0[2] = x0[2] - dx[2]
    dx[2] = dx[2]*2.0

    xcent = np.array([2.35, 0.15, 0.0])
    xvec = xcent - x0
    shift = np.dot(Ry,xvec) - xvec

    ## theta and rotation matrix calculated earlier
    inClip.ClipType.Position = x0 - shift
    inClip.ClipType.Length = dx


def pitchClip(inClip, pitchdeg):

    theta=pitchdeg*np.pi/180.0

    Rx = np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0, np.sin(theta), np.cos(theta)]])
    Ry = np.array([[np.cos(theta),0,np.sin(theta)],[0,1,0],[-np.sin(theta), 0, np.cos(theta)]])
    Rz = np.array([[np.cos(theta), -np.sin(theta),0],[np.sin(theta), np.cos(theta),0],[0,0,1]])
    ## doing z rotation here
    R=Rz

    inClip.ClipType.Rotation = [0.0, 0.0, pitchdeg]

    ### want this rotated about 2.35 0.15 0
    #x0 = np.array(inClip.ClipType.Position)
    #dx = np.array(inClip.ClipType.Length)

    ## rotation center
    #xcent = np.array([0.0, 0.15, 0.0])
    #xvec = xcent - x0
    #shift = np.dot(Ry,xvec) - xvec

    ### theta and rotation matrix calculated earlier
    #inClip.ClipType.Position = x0 - shift
    #inClip.ClipType.Length = dx


# state file generated using paraview version 5.8.0

# ----------------------------------------------------------------
# setup views used in the visualization
# ----------------------------------------------------------------
# trace generated using paraview version 5.8.0
#
# To ensure correct image size when batch processing, please search 
# for and uncomment the line `# renderView*.ViewSize = [*,*]`

#### import the simple module from the paraview
from paraview.simple import *
#### disable automatic camera reset on 'Show'
paraview.simple._DisableFirstRenderCameraReset()

# Create a new 'Render View'
renderView1 = CreateView('RenderView')
renderView1.ViewSize = [1920, 1080]
renderView1.AxesGrid = 'GridAxes3DActor'
renderView1.CenterOfRotation = [2.3499999046325684, -2.4999999999999862, 0.24325000593671575]
renderView1.StereoType = 'Crystal Eyes'
renderView1.CameraPosition = [2.5152672595046077, -1.5219613597156005, 6.7251781938166495]
renderView1.CameraFocalPoint = [2.5152672595046077, -1.5219613597156005, -41.968545220391206]
renderView1.CameraFocalDisk = 1.0
renderView1.CameraParallelScale = 12.60286299655153

SetActiveView(None)

scrpath='../scripts/'
imgpath='./images/'
from pathlib import Path
Path(imgpath).mkdir(parents=True, exist_ok=True)

magenta= [1.0, 0.0, 1.0]
black  = [0.0, 0.0, 0.0]
white  = [1.0, 1.0, 1.0]

fontsize = 32

# ----------------------------------------------------------------
# setup view layouts
# ----------------------------------------------------------------

# create new layout object 'Layout #1'
layout1 = CreateLayout(name='Layout #1')
layout1.AssignView(0, renderView1)

# ----------------------------------------------------------------
# restore active view
SetActiveView(renderView1)
# ----------------------------------------------------------------

# ----------------------------------------------------------------
# script to grab block information
# ----------------------------------------------------------------

def getBlockIndices(compositeDataInformation, index=0):

    localDict = {}

    if compositeDataInformation.GetDataIsMultiPiece():
        index += compositeDataInformation.GetNumberOfChildren()
    else:
        if compositeDataInformation.GetDataIsComposite():
            for i in range(compositeDataInformation.GetNumberOfChildren()):
                index += 1
                _blockName = compositeDataInformation.GetName(i)
                localDict[_blockName] = index
                leafDict, index = getBlockIndices(compositeDataInformation.GetDataInformation(i).GetCompositeDataInformation(), index)
                localDict.update(leafDict)
    return localDict, index


# create a new 'OpenFOAMReader'
import os,sys
import numpy as np

cwd=os.getcwd()
casename=os.path.basename(cwd)

itank=0
yshift=0.0
if 'tank' in casename:
  itank=1
  yshift=0.15

camyshift=0
if '2xgap' in casename:
  camyshift=0.15
  renderView1.CameraPosition = [2.5152672595046077, -1.5219613597156005+camyshift, 6.7251781938166495]
  renderView1.CameraFocalPoint = [2.5152672595046077, -1.5219613597156005+camyshift, -41.968545220391206]

# create a new 'OpenFOAMReader'
baselinefoam = OpenFOAMReader(FileName='./'+casename+'.foam')
# rename source object
RenameSource('baseline.foam', baselinefoam)
#baselinefoam = FindSource('baseline.foam')

## load all regions
#baselinefoam.MeshRegions = ['internalMesh', 'MOWT', 'flap1_back', 'flap1_front', 'flap2_back', 'flap2_front', 'flap3_back', 'flap3_front', 'flap4_back', 'flap4_front', 'flap5_back', 'flap5_front']
baselinefoam.MeshRegions.SelectAll()

#renderView1 = GetActiveViewOrCreate('RenderView')
#renderView1.Update()

## need to activate it to set cdi
Show(baselinefoam, renderView1)
cdi=baselinefoam.GetDataInformation().GetCompositeDataInformation()
Hide(baselinefoam, renderView1)
## get block listing
blockinfo,nblocks=getBlockIndices(cdi)

# comment out to read all variables
#baselinefoam.CellArrays = ['Co', 'U', 'p', 'k', 'nut', 'omega']

## get time information
animationScene1 = GetAnimationScene()
timeList=animationScene1.TimeKeeper.TimestepValues
## go to last one
animationScene1.AnimationTime=timeList[-1]

## undo scaling if this is a scaled run
if '_10x' in casename:
    xscale=0.1
elif '_0.1x' in casename:
    xscale=10.0
## make the translation the new baseline for the rest of the script
if '_10x' in casename or '_0.1x' in casename:
    baselinefoamOrig=baselinefoam

    # create a new 'Calculator'
    # stupid workaround to prevent U from scaling with transform
    calculatorA = Calculator(Input=baselinefoamOrig)
    calculatorA.Function = 'U'
    calculatorA.AttributeType = 'Point Data'
    calculatorB = Calculator(Input=calculatorA)
    calculatorB.Function = 'U'
    calculatorB.AttributeType = 'Cell Data'
    
    baselinefoam = Transform(calculatorB)
    baselinefoam.Transform = 'Transform'
    baselinefoam.Transform.Scale = [xscale,xscale,xscale]
    # Properties modified on transform1.Transform
    baselinefoam.TransformAllInputVectors = 0
    Hide(baselinefoam, renderView1)


## Extract oll of the parts separately

# Extract 'flow' block
flow = ExtractBlock(Input=baselinefoam)
idx = blockinfo['internalMesh']
flow.BlockIndices = [idx]
RenameSource('Flow', flow)

# update the view to ensure updated data information
renderView1 = GetActiveViewOrCreate('RenderView')
renderView1.Update()

# device bottom
device = ExtractBlock(Input=baselinefoam)
idxList=[]
idxList.append(blockinfo['MOWT'])
if itank == 1:
    idxList.append(blockinfo['slip'])
device.BlockIndices = idxList
RenameSource('Device', device)

# Fronts
flapFronts = ExtractBlock(Input=baselinefoam)
idxList = [value for key, value in blockinfo.items() if '_front' in key ]
flapFronts.BlockIndices = idxList
RenameSource('FlapFronts', flapFronts)

# Backs
flapBacks = ExtractBlock(Input=baselinefoam)
idxList = [value for key, value in blockinfo.items() if '_back' in key ]
flapBacks.BlockIndices = idxList
RenameSource('FlapBacks', flapBacks)

# create a vertical midplane 'Slice' through flow
verticalSlice = Slice(Input=flow)
RenameSource('Vertical Slice', verticalSlice)
verticalSlice.SliceType = 'Plane'
# init the 'Plane' selected for 'SliceType'
verticalSlice.SliceType.Origin = [2.3499999046325684, -2.4999999999999862, -0.001]
verticalSlice.SliceType.Normal = [0.0, 0.0, 1.0]

## remove that stupid box
# toggle 3D widget visibility (only when running from the GUI)
Hide3DWidgets(proxy=verticalSlice.SliceType)
Hide(verticalSlice, renderView1)


# Reflect device surface
ireflectz=1
yawdeg=0.0
pitchdeg=0.0

if '15deg-pitch' in casename:
  pitchdeg=-15.0
if '30deg-pitch' in casename:
  pitchdeg=-30.0
if '35deg-pitch' in casename:
  pitchdeg=-35.0
if '40deg-pitch' in casename:
  pitchdeg=-40.0
if '45deg-pitch' in casename:
  pitchdeg=-45.0
if '60deg-pitch' in casename:
  pitchdeg=-60.0

if '15deg-yaw' in casename:
  ireflectz=0
  yawdeg=-15.0
if '30deg-yaw' in casename:
  ireflectz=0
  yawdeg=-30.0

if 'deg-yaw' in casename:
  theta=yawdeg*np.pi/180.0
  Rx = np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0, np.sin(theta), np.cos(theta)]])
  Ry = np.array([[np.cos(theta),0,np.sin(theta)],[0,1,0],[-np.sin(theta), 0, np.cos(theta)]])
  Rz = np.array([[np.cos(theta), -np.sin(theta),0],[np.sin(theta), np.cos(theta),0],[0,0,1]])
  ## doing y rotation here
  R=Ry

  ## yaw the slice place
  ## plane norm is R.[0,0,1]
  nrm = np.dot(R,np.array(verticalSlice.SliceType.Normal))
  verticalSlice.SliceType.Normal = nrm
  #verticalSlice.SliceType.Normal = [np.sin(rads), 0.0, np.cos(rads)]

  ## project velocity to plane for glyphs
  # Properties modified on calculator1
  calculator1 = Calculator(Input=verticalSlice)
  calculator1.AttributeType = 'Cell Data'
  calculator1.ResultArrayName = 'planeU'
  ## projection is Uvector - U.norm*norm = U.(I - R.z*z))
  ## equation = U - (U_X*nx + U_Y*ny + U_Z*nz)*(nxi*iHat + ny*jHat + nz*kHat)
  equation = 'U - (U_X*{0:.6f} + U_Y*{1:.6f} + U_Z*{2:.6f})*({0:.6f}*iHat + {1:.6f}*jHat + {2:.6f}*kHat)'.format(nrm[0],nrm[1],nrm[2])
  calculator1.Function = equation

  vslice=calculator1
  # don't mirror in y
  ## turn on parts:
  mowt=device
  backs=flapBacks
  fronts=flapFronts
else:
  reflect1 = Reflect(Input=device)
  reflect1.CopyInput = 1
  reflect1.Plane = 'Z Max'
  #reflect1.CopyInput = 0

  # reflect flap fronts
  reflect2 = Reflect(Input=flapFronts)
  reflect2.Plane = 'Z Max'

  # Reflect flap backs
  reflect3 = Reflect(Input=flapBacks)
  reflect3.Plane = 'Z Max'

  mowt=reflect1
  fronts=reflect2
  backs=reflect3

  vslice=verticalSlice

# show data from verticalSlice
vsliceDisplay = Show(vslice, renderView1, 'GeometryRepresentation')

## turn on parts:
Show(mowt, renderView1) # MOWT Surface
#Show(fronts, renderView1)
#Hide(backs, renderView1)
Show(backs, renderView1)
Hide(fronts, renderView1)


## Tune the pressure legend
pmin = -1.5
pmax =  2.1

# get color transfer function/color map for 'Velocity'
pLUT = GetColorTransferFunction('p')
pLUT.AutomaticRescaleRangeMode = 'Never'
#pLUT.ScalarRangeInitialized = 1

# get opacity transfer function/opacity map for 'Velocity'
pPWF = GetOpacityTransferFunction('p')
#pPWF.Points = [0.004319478077955337, 0.0, 0.5, 0.0, 0.9701205864277093, 1.0, 0.5, 0.0]
#pPWF.ScalarRangeInitialized = 1

# Rescale transfer function
pLUT.RescaleTransferFunction(pmin, pmax)

# Rescale transfer function
pPWF.RescaleTransferFunction(pmin, pmax)

# Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
#pLUT.ApplyPreset('Viridis (matplotlib)', True)
pLUT.ApplyPreset('Cool to Warm', True)

# trace defaults for the display properties.
vsliceDisplay.Representation = 'Surface'
vsliceDisplay.ColorArrayName = ['POINTS', 'p']
vsliceDisplay.LookupTable = pLUT
vsliceDisplay.OSPRayScaleArray = 'p'

# get color legend/bar for velocityLUT in view renderView1
pLUTColorBar = GetScalarBar(pLUT, renderView1)
pLUTColorBar.WindowLocation = 'AnyLocation'

pLUTColorBar.Title = 'Pressure'
pLUTColorBar.ComponentTitle = ''

# change scalar bar placement

## for vertical
##pLUTColorBar.Orientation = 'Vertical'
#legendLength=0.33
##xpos=0.8
##ypos = (1.0-legendLength)/2.0

pLUTColorBar.Orientation = 'Horizontal'
legendLength=0.5
xpos = (1.0-legendLength)/2.0
ypos=0.01

pLUTColorBar.Position = [xpos,ypos]
pLUTColorBar.ScalarBarLength = legendLength
pLUTColorBar.Visibility = 1

pLUTColorBar.UseCustomLabels = 1
pLUTColorBar.CustomLabels = np.linspace(pmin,pmax,5)

pLUTColorBar.TitleFontSize = fontsize
pLUTColorBar.LabelFontSize = fontsize
pLUTColorBar.ScalarBarThickness = fontsize

## # create a new 'Glyph'
## glyph3 = Glyph(Input=flow,
##     GlyphType='Arrow')
## glyph3.OrientationArray = ['CELLS', 'U']
## glyph3.ScaleArray = ['CELLS', 'U']
## glyph3.ScaleFactor = 0.5
## glyph3.GlyphTransform = 'Transform2'
## glyph3.GlyphMode = 'Uniform Spatial Distribution (Surface Sampling)'
## glyph3.MaximumNumberOfSamplePoints = 1000
## glyph3.Stride = 250
## 
## # create a new 'Reflect'
## reflect4 = Reflect(Input=glyph3)
## reflect4.Plane = 'Z Max'
## 

# create a new 'Clip'
innerClip = Clip(Input=vslice)
RenameSource('Inner Clip',innerClip)
innerClip.ClipType = 'Box'
innerClip.HyperTreeGridClipper = 'Plane'
innerClip.Scalars = ['POINTS', 'p']
innerClip.Value = -0.005844473838806152

# init the 'Box' selected for 'ClipType'
if itank == 0:
    innerClip.ClipType.Position = [0.6, 0.0, 0.001]
    innerClip.ClipType.Length = [4.5, -0.8, -2.0]
else:
    innerClip.ClipType.Position = [0.2, 0.0, 0.001]
    innerClip.ClipType.Length = [5, -1.2, -2.0]

if 'deg-pitch' in casename:
    pitchClip(innerClip, pitchdeg)
if 'deg-yaw' in casename:
    yawClip(innerClip, yawdeg)

# init the 'Plane' selected for 'HyperTreeGridClipper'
innerClip.HyperTreeGridClipper.Origin = [2.3499999046325684, -2.4999999999999867, -0.0010000000474974513]

# create a new 'Glyph'
glyph2 = Glyph(Input=innerClip,
    GlyphType='Arrow')
if 'deg-yaw' in casename:
  glyph2.OrientationArray = ['CELLS', 'planeU']
  glyph2.ScaleArray = ['CELLS', 'planeU']
else:
  glyph2.OrientationArray = ['CELLS', 'U']
  glyph2.ScaleArray = ['CELLS', 'U']
glyph2.ScaleFactor = 0.5
glyph2.GlyphTransform = 'Transform2'
glyph2.MaximumNumberOfSamplePoints = 500
if ireflectz == 0 :
  glyph2.MaximumNumberOfSamplePoints = 2*glyph2.MaximumNumberOfSamplePoints
if '1flap-gap-channel' in casename:
  glyph2.MaximumNumberOfSamplePoints = 100

# show data in view
glyph2Display = Show(glyph2, renderView1)
glyph2Display.ColorArrayName = ['POINTS', '']
#Hide(glyph2, renderView1)

arrowColor=white
glyph2Display.AmbientColor = arrowColor
glyph2Display.DiffuseColor = arrowColor



# create a new 'Clip'
innerClip2 = Clip(Input=vslice)
RenameSource('Inner Clip 2',innerClip2)
innerClip2.ClipType = 'Box'
innerClip2.HyperTreeGridClipper = 'Plane'
innerClip2.Scalars = ['POINTS', 'p']
innerClip2.Value = -0.005844473838806152

# init the 'Box' selected for 'ClipType'
if itank == 0:
    innerClip2.ClipType.Position = [0.6, -0.7, 0.001]
    innerClip2.ClipType.Length = [4.3, -0.35, -2.0]
else:
    innerClip2.ClipType.Position [0.6, -0.9, 0.001]
    innerClip2.ClipType.Length = [4.3, -0.5, -2.0]

if 'deg-pitch' in casename:
    pitchClip(innerClip2, pitchdeg)
if 'deg-yaw' in casename:
    yawClip(innerClip2, yawdeg)

# init the 'Plane' selected for 'HyperTreeGridClipper'
innerClip2.HyperTreeGridClipper.Origin = [2.3499999046325684, -2.4999999999999867, -0.0010000000474974513]

# create a new 'Clip'
outerClip = Clip(Input=vslice)
RenameSource('Outer Clip',outerClip)
outerClip.ClipType = 'Box'
outerClip.HyperTreeGridClipper = 'Plane'
outerClip.Scalars = ['POINTS', 'p']
outerClip.Value = -0.005844473838806152

# init the 'Box' selected for 'ClipType'
outerClip.ClipType.Position = [-1.0, 0.0, 0.001]
outerClip.ClipType.Length = [8.0, -2.0, -2.0]

if 'deg-pitch' in casename:
    pitchClip(outerClip, pitchdeg)
if 'deg-yaw' in casename:
    yawClip(outerClip, yawdeg)

# init the 'Plane' selected for 'HyperTreeGridClipper'
outerClip.HyperTreeGridClipper.Origin = [2.3499999046325684, -2.4999999999999867, -0.0010000000474974513]

# create a new 'Glyph'
glyph1 = Glyph(Input=outerClip,
    GlyphType='Arrow')
if 'deg-yaw' in casename:
  glyph1.OrientationArray = ['CELLS', 'planeU']
  glyph1.ScaleArray = ['CELLS', 'planeU']
else:
  glyph1.OrientationArray = ['CELLS', 'U']
  glyph1.ScaleArray = ['CELLS', 'U']
glyph1.ScaleFactor = 0.5
glyph1.GlyphTransform = 'Transform2'
glyph1.GlyphMode = 'Uniform Spatial Distribution (Surface Sampling)'
glyph1.MaximumNumberOfSamplePoints = 50
if ireflectz == 0 :
  glyph1.MaximumNumberOfSamplePoints = 2*glyph1.MaximumNumberOfSamplePoints
glyph1.Stride = 250

# show data in view
#SetActiveSource(glyph1)
glyph1Display = Show(glyph1, renderView1)
glyph1Display.ColorArrayName = ['POINTS', '']
# hide data in view
#Hide(glyph1, renderView1)

arrowColor=white
#arrowColor=black

# change solid color
glyph1Display.AmbientColor = arrowColor
glyph1Display.DiffuseColor = arrowColor


# create a new 'Glyph'
glyph5 = Glyph(Input=innerClip2,
    GlyphType='Arrow')
if 'deg-yaw' in casename:
  glyph5.OrientationArray = ['CELLS', 'planeU']
  glyph5.ScaleArray = ['CELLS', 'planeU']
else:
  glyph5.OrientationArray = ['CELLS', 'U']
  glyph5.ScaleArray = ['CELLS', 'U']
glyph5.ScaleFactor = 0.5
glyph5.GlyphTransform = 'Transform2'
glyph5.MaximumNumberOfSamplePoints = 20
if ireflectz == 0 :
  glyph5.MaximumNumberOfSamplePoints = 2*glyph5.MaximumNumberOfSamplePoints

# show data in view
glyph5Display = Show(glyph5, renderView1)
glyph5Display.ColorArrayName = ['POINTS', '']
#Hide(glyph5, renderView1)

arrowColor=white
glyph5Display.AmbientColor = arrowColor
glyph5Display.DiffuseColor = arrowColor

if '45deg-pitch' in casename:
    loadCamera(scrpath+'pitch45side.pvcvbc')
elif '60deg-pitch' in casename:
    loadCamera(scrpath+'pitch60side.pvcvbc')

## SAVE IMAGE
SaveScreenshot(imgpath+'pressure.png', renderView1, ImageResolution=[1920, 1080],
FontScaling='Do not scale fonts',
TransparentBackground=0,
OverrideColorPalette='PrintBackground')

## color slice by velocity
vmin=0.0
vmax=2.0

# get color transfer function/color map for 'Velocity'
velocityLUT = GetColorTransferFunction('Velocity')
velocityLUT.AutomaticRescaleRangeMode = 'Never'
#velocityLUT.ScalarRangeInitialized = 1

# get opacity transfer function/opacity map for 'Velocity'
velocityPWF = GetOpacityTransferFunction('Velocity')

# Rescale transfer function
velocityLUT.RescaleTransferFunction(vmin, vmax)

# Rescale transfer function
velocityPWF.RescaleTransferFunction(vmin, vmax)

velocityLUT.ApplyPreset('Viridis (matplotlib)', True)
ColorBy(vsliceDisplay, ('POINTS', 'U', 'Magnitude'))

vsliceDisplay.ColorArrayName = ['POINTS', 'U']
vsliceDisplay.LookupTable = velocityLUT
vsliceDisplay.OSPRayScaleArray = 'U'

velocityLUTColorBar = GetScalarBar(velocityLUT, renderView1)
velocityLUTColorBar.WindowLocation = 'AnyLocation'

velocityLUTColorBar.Title = 'Velocity'
velocityLUTColorBar.ComponentTitle = 'Magnitude'

#velocityLUTColorBar.Orientation = 'Vertical'
#legendLength=0.33
#xpos=0.8
#ypos = (1.0-legendLength)/2.0

velocityLUTColorBar.Orientation = 'Horizontal'
legendLength=0.5
xpos = (1.0-legendLength)/2.0
ypos=0.01

velocityLUTColorBar.Position = [xpos,ypos]
velocityLUTColorBar.ScalarBarLength = legendLength

# set color bar visibility
pLUTColorBar.Visibility = 0
velocityLUTColorBar.Visibility = 1

# Properties modified on velocityLUTColorBar
velocityLUTColorBar.UseCustomLabels = 1
velocityLUTColorBar.CustomLabels = np.linspace(vmin,vmax,5)

velocityLUTColorBar.TitleFontSize = fontsize
velocityLUTColorBar.LabelFontSize = fontsize
velocityLUTColorBar.ScalarBarThickness = fontsize

## SAVE IMAGE
SaveScreenshot(imgpath+'velocity.png', renderView1, ImageResolution=[1920, 1080],
FontScaling='Do not scale fonts',
TransparentBackground=0,
OverrideColorPalette='PrintBackground')

##turn everything off
Hide(vslice, renderView1)
#Hide(mowt, renderView1) # MOWT Surface
Show(fronts, renderView1) # flap fronts
Hide(backs, renderView1) # flap backs
Hide(glyph1, renderView1)
Hide(glyph2, renderView1)
Hide(glyph5, renderView1)


# create a new 'Slice'
horizontalSlice = Slice(Input=flow)
RenameSource('Horizontal Slice', horizontalSlice)
horizontalSlice.SliceType = 'Plane'
horizontalSlice.HyperTreeGridSlicer = 'Plane'
horizontalSlice.SliceOffsetValues = [0.0]

# init the 'Plane' selected for 'SliceType'
#horizontalSlice.SliceType.Origin = [2.3499999046325684, -0.05+yshift, -2.499999999999794]
horizontalSlice.SliceType.Origin = [0.0, -0.05+yshift, -2.499999999999794]
horizontalSlice.SliceType.Normal = [0.0, 1.0, 0.0]

if 'deg-pitch' in casename:

  theta=pitchdeg*np.pi/180.0
  Rx = np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0, np.sin(theta), np.cos(theta)]])
  Ry = np.array([[np.cos(theta),0,np.sin(theta)],[0,1,0],[-np.sin(theta), 0, np.cos(theta)]])
  Rz = np.array([[np.cos(theta), -np.sin(theta),0],[np.sin(theta), np.cos(theta),0],[0,0,1]])
  ## doing z rotation here
  R=Rz

  ## pitch the slice place
  nrm = np.dot(R,np.array(horizontalSlice.SliceType.Normal))
  horizontalSlice.SliceType.Normal = nrm

  ## project velocity to plane for glyphs
  # Properties modified on calculator1
  calculator1 = Calculator(Input=horizontalSlice)
  calculator1.AttributeType = 'Cell Data'
  calculator1.ResultArrayName = 'planeU'
  ## projection is Uvector - U.norm*norm = U.(I - R.z*z))
  ## equation = U - (U_X*nx + U_Y*ny + U_Z*nz)*(nxi*iHat + ny*jHat + nz*kHat)
  equation = 'U - (U_X*{0:.6f} + U_Y*{1:.6f} + U_Z*{2:.6f})*({0:.6f}*iHat + {1:.6f}*jHat + {2:.6f}*kHat)'.format(nrm[0],nrm[1],nrm[2])
  calculator1.Function = equation

  ## I think this is ok
  Hide(horizontalSlice, renderView1)
  horizontalSlice=calculator1

# create a new 'Reflect'

if ireflectz == 1 :
    Hide(horizontalSlice, renderView1)
    reflect5 = Reflect(Input=horizontalSlice)
    reflect5.Plane = 'Z Max'
    hslice=reflect5
else:
    hslice=horizontalSlice

hsliceDisplay = Show(hslice, renderView1)
hsliceDisplay.Representation = 'Surface'
hsliceDisplay.ColorArrayName = ['POINTS', 'U']
hsliceDisplay.LookupTable = velocityLUT
hsliceDisplay.OSPRayScaleArray = 'U'

# create a new 'Glyph'
glyph4 = Glyph(Input=hslice,
    GlyphType='Arrow')
if 'deg-pitch' in casename:
  glyph4.OrientationArray = ['CELLS', 'planeU']
  glyph4.ScaleArray = ['CELLS', 'planeU']
else:
  glyph4.OrientationArray = ['CELLS', 'U']
  glyph4.ScaleArray = ['CELLS', 'U']
glyph4.ScaleFactor = 0.25
glyph4.GlyphTransform = 'Transform2'
glyph4.MaximumNumberOfSamplePoints = 300
#if ireflectz == 0 :
#  glyph4.MaximumNumberOfSamplePoints = 2*glyph4.MaximumNumberOfSamplePoints

Show(hslice, renderView1)
Show(glyph4, renderView1)

#Turn pressure legend back on
# set color bar visibility
pLUTColorBar.Visibility = 1

#move velocity legend out of the way
velocityLUTColorBar.Visibility = 1
velocityLUTColorBar.Orientation = 'Vertical'
xpos=0.8
ypos = (1.0-legendLength)/2.0

velocityLUTColorBar.Position = [xpos,ypos]
velocityLUTColorBar.ScalarBarLength = legendLength
velocityLUTColorBar.CustomLabels = np.linspace(vmin,vmax,3)


##fronts
# current camera placement for renderView1
renderView1.CameraPosition = [-2.5, -1.456999766300541, -2.195210006020258]
renderView1.CameraFocalPoint = [48.623877952308256, 16.88716724400919, 20.707377267386427]
renderView1.CameraViewUp = [0.2829299685510813, -0.9502935595960602, 0.129972241213012]
renderView1.CameraParallelScale = 12.60286299655153
if '15deg-pitch' in casename:
  ## tilt camera
  #GetActiveCamera().Pitch(-1.0*pitchdeg)
  GetActiveCamera().Pitch(15)
  #GetActiveCamera().Zoom(0.5);
elif '30deg-pitch' in casename:
    loadCamera(scrpath+'pitch30fronts.pvcvbc')
elif '35deg-pitch' in casename:
    loadCamera(scrpath+'pitch35fronts.pvcvbc')
elif '40deg-pitch' in casename:
    loadCamera(scrpath+'pitch40fronts.pvcvbc')
elif '45deg-pitch' in casename:
    loadCamera(scrpath+'pitch45fronts.pvcvbc')
elif '60deg-pitch' in casename:
    loadCamera(scrpath+'pitch60fronts.pvcvbc')

## SAVE IMAGE
SaveScreenshot(imgpath+'pressure_fronts.png', renderView1, ImageResolution=[1920, 1080],
FontScaling='Do not scale fonts',
TransparentBackground=0,
OverrideColorPalette='PrintBackground')


###backs
Hide(fronts, renderView1) # flap fronts
Show(backs, renderView1) # flap backs

# current camera placement for renderView1
renderView1.CameraPosition = [7.4, -1.456999766300541, 2.195210006020258]
renderView1.CameraFocalPoint = [-48.623877952308256, 16.88716724400919, -20.707377267386427]
renderView1.CameraViewUp = [-0.2829299685510813, -0.9502935595960602, -0.129972241213012]
renderView1.CameraParallelScale = 12.60286299655153

#if 'deg-pitch' in casename:
if '15deg-pitch' in casename:
  GetActiveCamera().Elevation(1)
elif '30deg-pitch' in casename:
    loadCamera(scrpath+'pitch30backs.pvcvbc')
elif '35deg-pitch' in casename:
    loadCamera(scrpath+'pitch35backs.pvcvbc')
elif '40deg-pitch' in casename:
    loadCamera(scrpath+'pitch40backs.pvcvbc')
elif '45deg-pitch' in casename:
    loadCamera(scrpath+'pitch45backs.pvcvbc')
elif '60deg-pitch' in casename:
    loadCamera(scrpath+'pitch60backs.pvcvbc')


## SAVE IMAGE
SaveScreenshot(imgpath+'pressure_backs.png', renderView1, ImageResolution=[1920, 1080],
FontScaling='Do not scale fonts',  # font sizes are specified at 32
TransparentBackground=0,
OverrideColorPalette='PrintBackground')
